#ifndef DELAY_H
#define DELAY_H

#include "STime.h"
#include "Dal.h"

#include <vector>
#include <utility>
#include <map>

typedef std::pair<STime,double> delay_pair;

class Delay {

 public:

  double getSignalDelay(STime ertTime, unsigned char GSID);
  double getXMCSGSdelay(STime ertTime, unsigned char GSID);
  double getXMCSOBDHdelay(STime ertTime);
  double getActualGSdelay(STime ertTime, unsigned char GSID);
  double getActualOBDHdelay(STime ertTime);

  Delay();
  ~Delay() {};


 private:

  std::map<unsigned int, std::vector<delay_pair> > xmcsDelays;

  std::map<unsigned int, std::vector<delay_pair> > actualDelays;

  
};

#endif
