#include "Revolution.h"

#include "STime.h"
#include "errstr.h"
 
#include <fstream>

Revolution::Revolution() {
  
  std::ifstream revnofile("revno.txt");
  
  string timestring;
  int r;
  
  if (!revnofile) {

    errstr << "Cannot open REVNO file" << Sas::fatal("REVNO");

  }

  while (!revnofile.eof()){

    revnofile >> r >> timestring;
    revList[r] = STime(timestring);
  }

  revnofile.close();

}

STime Revolution::getStart(int rev) {
  
  return revList[rev];
  
}

STime Revolution::getEnd(int rev){
  
  STime t = revList[rev + 1];

  return t - 1.0;

}

int Revolution::getRev(STime t) {

  int r = 0;

  map<int,STime>::iterator i;
  for (i = revList.begin(); i != revList.end(); i++) {

    if ((*i).second > t) {
      r = (*i).first;
      break;
    }
    
  }

  return r - 1;
  
}
