// SPRx22 jcv 4-Feb-2010 gcc4 migration

#ifndef UTILS_H
#define UTILS_H

#include "STime.h"


namespace Utils {

  typedef struct 
  {
    unsigned short	Days;
    unsigned int	Milliseconds;
    unsigned short	Microseconds;
  } __attribute__ ((packed)) CDSTime ;
  
  typedef struct 
  {
    unsigned int	TCoarse;
    unsigned short	TFine;
  } __attribute__ ((packed)) CUCTime ;

  typedef long long signed int vmsTime;
  
  typedef struct 
  {
    unsigned int	Seconds;
    unsigned int	Microseconds;
//    unsigned short	dummy;
  } __attribute__ ((packed)) tdsTime;

  const unsigned long long int UNIX_EPOCH0_IN_VMS_TIME = 0x007C95674BEB4000LL;

  const signed int MJD2CDS = 36204;

  void vmsByteSwap(unsigned char *buf, int size);
  
  void sunByteSwap(unsigned char *buf, int size);

  // SPRx22 gcc4 migration
  //signed int Utils::sign(double d);
  signed int sign(double d);
  
  STime readVMSTime(Utils::vmsTime time);
  STime readTDSTime(Utils::tdsTime time);

  STime cds2STime(Utils::CDSTime Time);
  Utils::CDSTime STime2cds(STime Time);

  double STime2MJD2000(STime time);
  STime MJD20002STime(double mjd2000);

}

#endif

